use Std.Textio.all;
library IEEE;
  use ieee.std_logic_1164.ALL;
  
entity test_c_register is
end;

architecture test_c_register of test_c_register is

component c_register
	generic(width : integer := 4);
	port (input : in std_logic_vector((width-1) downto 0);
        	WR: in std_logic;
        	reset : in std_logic;
        	clock : in std_logic;
        	output : out std_logic_vector((width -1) downto 0));
end component;

signal c_registerin : std_logic_vector(3 downto 0);
signal clock : std_logic;
signal clr : std_logic;
signal wrt : std_logic;
signal c_registerout : std_logic_vector(3 downto 0);

begin

c_register4 : c_register generic map(4)
	port map(input => c_registerin, 
		clock => clock, 
		reset => clr, 
		WE => wrt, 
		output => c_registerout);
	
test_process : process

	begin
	
	clr <= '1';
	wrt <= '0';
	c_registerin <= "1010";
	clock <= '0';
	wait for 10 ns;
	
	clock <= '1';
	wait for 10 ns;
	
	clr <= '0';
	wrt <= '1';
	clock <= '0';
	wait for 10 ns;
	
	clock <= '1';
	wait for 10 ns;
	
	c_registerin <= "0101";
	clock <= '0';
	wait for 10 ns;
	
	clock <= '1';
	wait for 10 ns;
	
	wrt <= '0';
	clock <= '0';
	wait for 10 ns;
	
	clock <= '1';
	wait for 10 ns;
	
	c_registerin <= "1111";
	clock <= '0';
	wait for 10 ns;
	
	clock <= '1';
	wait for 10 ns;
	
	wrt <= '1';
	clock <= '0';
	wait for 10 ns;
	
	clock <= '1';
	wait for 10 ns;
	
	clock <= '0';
	wait for 10 ns;
	wait;
	
end process test_process;
end test_c_register;
